#define STRICT
#include <windows.h>

#include "dbghelp.hpp"

using namespace std;

namespace{
    typedef PVOID (WINAPI *ImageDirectoryEntryToDataFunc)(PVOID, BOOLEAN, USHORT, PULONG);
    HMODULE hDbghelp = 0;
    ImageDirectoryEntryToDataFunc p_ImageDirectoryEntryToData = 0;
}

namespace dbghelp{
    bool init()
    {
        if(!(hDbghelp = LoadLibrary("dbghelp.dll"))) return false;
        if(!(p_ImageDirectoryEntryToData = reinterpret_cast<ImageDirectoryEntryToDataFunc>(
            GetProcAddress(hDbghelp, "ImageDirectoryEntryToData")))) return false;
        return true;
    }

    bool fin()
    {
        p_ImageDirectoryEntryToData = 0;
        if(hDbghelp){
            if(!FreeLibrary(hDbghelp)) return false;
            hDbghelp = 0;
        }
        return true;
    }

    PVOID ImageDirectoryEntryToData(PVOID Base, BOOLEAN MappedAsImage, USHORT DirectoryEntry, PULONG Size)
    {
        return p_ImageDirectoryEntryToData(Base, MappedAsImage, DirectoryEntry, Size);
    }
}
