#ifndef TASRYOKO_IAT_HPP
#define TASRYOKO_IAT_HPP

#define STRICT
#include <windows.h>

namespace IAT{
    // (関数名, フック関数)
    struct Hook{
        const char* name;
        FARPROC func;
    };
    // (DLL名, Hook配列)
    struct Patch{
        const char* dll;
        const Hook* hooks;
    };

    /**
     * patches の内容に従ってIATパッチを行う。ただし excmods に含まれるモ
     * ジュールは無視する。
     *
     * patches の終端は {0,0}, patches->hooks の終端は全て {0,0}, excmods の
     * 終端は 0 にすること。
     *
     * DLL injectionと併用する場合、injectされるDLLは excmods に含めておかな
     * いと本物のAPIを呼び出せなくなるので注意。
     */
    bool patch(const Patch* patches, const char** excmods);
}

#endif /* TASRYOKO_IAT_HPP */
