#ifndef TASRYOKO_TAS_HPP
#define TASRYOKO_TAS_HPP

#include <string>

#define STRICT
#include <windows.h>

#include "movie.hpp"
#include "types.hpp"

namespace TAS{
    enum MovieMode{ MOVIE_NONE, MOVIE_PLAY, MOVIE_REC };

    const ulong FRAME_WAIT_DEF = 16;

    HINSTANCE getHInstDLL();

    void frameadv();
    bool isPaused();
    void setPause(bool paused);
    ulong getFrameWait();
    void setFrameWait(ulong ms);

    void retryStage();

    Movie::Input getInput();
    Movie::Input::Op getInput(Movie::Input::Button btn);
    void setInput(Movie::Input input);
    void setInput(Movie::Input::Button btn, Movie::Input::Op op);

    MovieMode getMovieMode();
    void setMovieMode(MovieMode mode);
    const Movie& getMovie();
    void setMovie(const Movie& movie);
    const std::string& getMoviePath();
    void setMoviePath(const std::string& path);

    Movie::State genMovieState();

    bool stateLoad(const Movie& state);
    bool stateSave(const std::string& path);

    void getPos(double& x, double& y);
    void getVel(double& vx, double& vy);
    ulong getRand();
    void setRand(ulong r);
    ulong getStage();
    ulong getFrameCount();

    ulong getAddrRand();
    void setAddrRand(ulong addr);

    ulong getAddrStage();
    void setAddrStage(ulong addr);

    ulong getAddrPosX();
    void setAddrPosX(ulong addr);
    bool searchAddrPosX(ulong& addr);

    struct Shiki{
        double x, y, vx, vy;
        ulong mode;
        ulong mode_timer;
        long bound_frame;
        ulong ob_count;
    };
    ulong getAddrShiki();
    void getShiki(Shiki& shiki);

    uint tasMain(HINSTANCE hInstDLL);
}

#endif /* TASRYOKO_TAS_HPP */
