#define STRICT
#include <windows.h>
#include <process.h>

#include "tas.hpp"
#include "types.hpp"

using namespace std;

namespace{
    const DWORD THREAD_QUIT_TIMEOUT = 3000;

    HINSTANCE hInstDLL = 0;
    HANDLE hThread = 0;
    uint tid = 0;

    uint __stdcall thread(void* args)
    {
        return TAS::tasMain(hInstDLL);
    }

    bool init(HINSTANCE a_hInstDLL)
    {
        hInstDLL = a_hInstDLL;
        return (hThread = reinterpret_cast<HANDLE>(_beginthreadex(0, 0, thread, 0, 0, &tid)));
    }

    bool fin()
    {
        if(!hThread) return true;
        DWORD st;
        GetExitCodeThread(hThread, &st);
        if(st == STILL_ACTIVE){
            PostThreadMessage(tid, WM_QUIT, 0, 0);
            WaitForSingleObject(hThread, THREAD_QUIT_TIMEOUT);
            CloseHandle(hThread);
        }
        hThread = 0;
        tid = 0;
        return true;
    }
}

/**
 * .def ファイルで最低1つはエクスポートシンボルを記述しないと、ソースファイ
 * ル内の全シンボルが勝手にエクスポートされてしまうようなので、ダミー関数を
 * 設ける。
 */
extern "C" void dummy() {}

extern "C" BOOL WINAPI DllMain(HINSTANCE a_hInstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    switch(fdwReason){
    case DLL_PROCESS_ATTACH:
        DisableThreadLibraryCalls(static_cast<HMODULE>(a_hInstDLL));
        if(!init(a_hInstDLL)) return FALSE;
        break;
    case DLL_PROCESS_DETACH:
        if(!fin()) return FALSE;
        break;
    default:
        break;
    }
    return TRUE;
}
